<template>
    <Layout class="bg-blue-grey-2">
        <q-page class="q-pa-md">
            <div class="row q-mb-md">
                <div class="col-12 col-md-3 q-px-sm">
                    <q-select option-value="id" option-label="name" :options="optionsProjects" outlined v-model="selectedProject" label="Selecione o projeto" ></q-select>
                </div>
                <div class="col-12 col-md-9 q-gutter-sm q-px-sm">
                </div>
            </div>
            <div class="row">
                <div class="col-12 col-md q-pa-sm">
                    <q-table
                        title="Membros do Quadro"
                        :rows="membersProjects"
                        :columns="columns"
                        row-key="name"
                    />
                </div>
                <div class="col-12 col-md q-pa-sm">
                    <q-table
                        title="Colunas do Quadro"
                        :rows="listsOfBoards"
                        :columns="columnsList"
                        row-key="name"
                    />
                </div>
            </div>
            <div class="row">
                <div class="col-12 col-md q-pa-sm">
                    <q-table
                        title="Cards do Quadro"
                        :rows="cardsOfBoard"
                        :columns="columnsCards"
                        row-key="name"
                        @row-click="loadActionsCard"
                        :filter="filter"
                    >
                        <template v-slot:top-right>
                            <q-input outlined dense v-model="filter" placeholder="Buscar card">
                                <template v-slot:append>
                                    <q-icon name="search" />
                                </template>
                            </q-input>
                        </template>
                    </q-table>
                </div>
            </div>
        </q-page>
    </Layout>
</template>

<script setup>
import { useQuasar } from "quasar";
import {onMounted, ref, watch} from 'vue';
import Layout from '../layouts/MainLayout.vue';
import { apiTrello } from "../httpclient/trello";
import { actionsDialog } from '../dialogs'

const $q = useQuasar()
const selectedProject = ref('Todos os projetos')
const optionsProjects = ref([])
const membersProjects = ref([])
const listsOfBoards = ref([])
const cardsOfBoard = ref([])
const filter = ref('')
const API_KEY = '9fd1927c336aa109846d00502ebcfafd'
const API_TOKEN = 'ATTAfd89216c9a32a483fa69be15a6027e8c14dbb22ab2f1bd675faa09b81590f6aaD751DB1D'

const columns = [
    {
        name: 'fullName',
        label: 'Nome',
        align: 'left',
        field: 'fullName',
    }
]

const columnsList = [
    {
        name: 'name',
        label: 'Nome',
        align: 'left',
        field: 'name',
    }
]

const columnsCards = [
    {
        name: 'name',
        label: 'Nome',
        align: 'left',
        field: 'name',
    }
]
async function loadProjects () {
    const allProjects = await apiTrello.get(`/1/members/me/boards?key=${API_KEY}&token=${API_TOKEN}`).catch(error => error)
    optionsProjects.value = allProjects.data
}
watch(() => selectedProject.value, (newValue) => {
    if (newValue) {
        loadMembers()
        loadListBoards()
        loadCards()
    }
})

async function loadListBoards () {
    const listBoard = await apiTrello.get(`/1/boards/${selectedProject.value.id}/lists?key=${API_KEY}&token=${API_TOKEN}`).catch(error => error)
    listsOfBoards.value = listBoard.data
}
async function loadMembers () {
    const allMembers = await apiTrello.get(`/1/boards/${selectedProject.value.id}/members?key=${API_KEY}&token=${API_TOKEN}`).catch(error => error)
    membersProjects.value = allMembers.data;
}

async function loadCards () {
    const allCards = await apiTrello.get(`/1/boards/${selectedProject.value.id}/cards?key=${API_KEY}&token=${API_TOKEN}`).catch(error => error)
    cardsOfBoard.value = allCards.data;
}

async function loadActionsCard (event, row, index) {
    const actionsCard = await apiTrello.get(`/1/cards/${row.id}/actions?key=${API_KEY}&token=${API_TOKEN}`).catch(error => error)
    $q.dialog({
        component: actionsDialog,
        componentProps: { arrayData: actionsCard.data }
    })
}

onMounted(() => {
    loadProjects()
})
</script>
